# Screen & Relax : A fast solving procedure for the Elastic-Net problem by safe identification of the solution support.

This repository implements the Screen & Relax method solving the Elastic-Net problem. We introduced this method in

**> ADD CITATION**

The above paper contains theoretical and numerical results that can be reproduced with this toolbox. If you encounter a bug or something unexpected, please let me know by raising an issue on the project page or by contacting me by [mail](theo.guyard@insa-rennes.fr).

## Requirements

`srenet` (**S**creen & **R**elax method for the **E**lastic-**NET** problem) package works with Python 3.9+. Please refer to the [Python download page](https://www.python.org/downloads/) for install instructions.

Dependencies :
* [NumPy](http://www.numpy.org)
* [SciPy](https://www.scipy.org)
* [Matplotlib](http://matplotlib.org)
* [Pandas](https://pandas.pydata.org)

## Install instructions

1. Clone the repository
```bash
git clone https://gitlab.insa-rennes.fr/Theo.Guyard/screen-and-relax.git
```

2. Enter the project folder
```bash
cd screen-and-relax
```

3. Ensure that Python 3.9+ is installed
```bash
python -V
> Python 3.9.1 (or higher)
```

4. Install external dependencies
```bash
pip install -r requirements.txt
```

5. Install the `srenet` package
```bash
pip install .
```

## ICASSP experiments

Experiments presented in the Screen & Relax paper are located in the folder `screen-and-relax/exp/ICASSP/`. The two available experiments are 
* `convergence.py` corresponding to figure 1
* `performance_profiles.py` corresponding to figure 2

To run experiments, make sure to be located at project root and run the corresponding python file :
```bash
cd screen-and-relax
python exp/ICASSP/convergence.py
python exp/ICASSP/performance_profiles.py
```

You can also edit the experimental setup directly in the script, which is well documented.

## Running demo examples

We also provide a notebook explaining how to use the `srenet` package. You can use it as following :
```bash
cd notebooks
jupyter notebook
```
You may have to install Jupyter. Please refer to the [Jupyter website](https://jupyter.org).

## Licence

This software is distributed under the [MIT Licence](https://mit-license.org).


## Cite this work

If you use this package for your own work, please consider citing it as :

**ADD CITATION**
